Loading...
Searching...
No Matches
basis_P1< T >

## Detailed Description

template<class T>
class rheolef::basis_P1< T >

Definition at line 31 of file P1.h.

Inheritance diagram for basis_P1< T >:

## Public Types

typedef basis_rep< T > | base
typedef base::size_type | size_type
Public Types inherited from basis_rep< T >
typedef reference_element::size_type | size_type
typedef T | value_type
typedef space_constant::valued_type | valued_type

## Public Member Functions

| basis_P1 (const basis_option &sopt)
| ~basis_P1 ()
bool | have_index_parameter () const
std::string | family_name () const
void | local_idof_on_side (reference_element hat_K, const side_information_type &sid, Eigen::Matrix< size_type, Eigen::Dynamic, 1 > &loc_idof) const
size_type | degree () const
bool | is_nodal () const
void | evaluate (reference_element hat_K, const point_basic< T > &hat_x, Eigen::Matrix< T, Eigen::Dynamic, 1 > &values) const
void | grad_evaluate (reference_element hat_K, const point_basic< T > &hat_x, Eigen::Matrix< point_basic< T >, Eigen::Dynamic, 1 > &values) const
void | _compute_dofs (reference_element hat_K, const Eigen::Matrix< T, Eigen::Dynamic, 1 > &f_xnod, Eigen::Matrix< T, Eigen::Dynamic, 1 > &dof) const
void | _initialize_cstor_sizes () const
void | _initialize_data (reference_element hat_K) const
const Eigen::Matrix< point_basic< T >, Eigen::Dynamic, 1 > & | hat_node (reference_element hat_K) const
Public Member Functions inherited from basis_rep< T >
| basis_rep (const basis_option &sopt)
virtual | ~basis_rep ()
virtual size_type | family_index () const
std::string | name () const
virtual valued_type | valued_tag () const
virtual bool | have_continuous_feature () const
virtual bool | is_hierarchical () const
virtual size_type | size () const
virtual const class basis_basic< T > & | operator[] (size_type i_comp) const
virtual bool | have_compact_support_inside_element () const
const basis_option & | option () const
const std::string & | valued () const
bool | is_continuous () const
bool | is_discontinuous () const
size_type | ndof (reference_element hat_K) const
size_type | nnod (reference_element hat_K) const
size_type | ndof_on_subgeo (size_type map_dim, size_type subgeo_variant) const
size_type | nnod_on_subgeo (size_type map_dim, size_type subgeo_variant) const
size_type | first_idof_by_dimension (reference_element hat_K, size_type dim) const
size_type | first_inod_by_dimension (reference_element hat_K, size_type dim) const
size_type | ndof_internal (reference_element hat_K) const
size_type | nnod_internal (reference_element hat_K) const
size_type | ndof_on_subgeo_internal (size_type map_dim, size_type subgeo_variant) const
size_type | nnod_on_subgeo_internal (size_type map_dim, size_type subgeo_variant) const
size_type | first_idof_by_dimension_internal (reference_element hat_K, size_type dim) const
size_type | first_inod_by_dimension_internal (reference_element hat_K, size_type dim) const
virtual size_type | local_ndof_on_side (reference_element hat_K, const side_information_type &sid) const
virtual const Eigen::Matrix< T, Eigen::Dynamic, Eigen::Dynamic > & | vdm (reference_element hat_K) const
virtual const Eigen::Matrix< T, Eigen::Dynamic, Eigen::Dynamic > & | inv_vdm (reference_element hat_K) const
const piola_fem< T > & | get_piola_fem () const
| _RHEOLEF_evaluate (evaluate,"scalar", T) _RHEOLEF_evaluate(evaluate
point_basic< T > | _RHEOLEF_evaluate (evaluate,"tensor", tensor_basic< T >) _RHEOLEF_evaluate(evaluate
point_basic< T > tensor3_basic< T > | _RHEOLEF_evaluate (evaluate,"tensor4", tensor4_basic< T >) _RHEOLEF_evaluate(grad_evaluate
point_basic< T > tensor3_basic< T > T | _RHEOLEF_evaluate (grad_evaluate,"vector", point_basic< T >) _RHEOLEF_evaluate(grad_evaluate
point_basic< T > tensor3_basic< T > T tensor_basic< T > | _RHEOLEF_evaluate (grad_evaluate,"tensor3", tensor3_basic< T >) _RHEOLEF_evaluate(grad_evaluate
| _RHEOLEF_evaluate_on_side ("scalar", T) _RHEOLEF_evaluate_on_side("vector"
| _RHEOLEF_compute_dofs ("scalar", T) _RHEOLEF_compute_dofs("vector"
point_basic< T > virtual _RHEOLEF_compute_dofs("tensor", tensor_basic< T >) void put(std void | put_scalar_valued (std::ostream &os, reference_element hat_K) const
virtual void | put_vector_valued (std::ostream &os, reference_element hat_K) const
void | put_hat_node (std::ostream &os, reference_element hat_K) const
void | put_hat_node_on_side (std::ostream &os, reference_element hat_K, const side_information_type &sid) const
void | _initialize_data_guard (reference_element hat_K) const
void | _clear () const

## Public Attributes

std::array< Eigen::Matrix< point_basic< T >, Eigen::Dynamic, 1 >, reference_element::max_variant > | _hat_node
Public Attributes inherited from basis_rep< T >
| vector
point_basic< T > | tensor3
point_basic< T > tensor3_basic< T > | scalar
point_basic< T > tensor3_basic< T > T | tensor
point_basic< T > tensor3_basic< T > T tensor_basic< T > | tensor4

## Additional Inherited Members

Static Public Member Functions inherited from basis_rep< T >
static basis_rep * | make_ptr (const std::string &name)
static std::string | standard_naming (std::string family_name, size_t degree, const basis_option &sopt)
static bool | have_index_parameter (std::string family_name)
static bool | have_continuous_feature (std::string family_name)
static void | _helper_initialize_first_ixxx_by_dimension_from_nxxx_on_subgeo (const std::array< std::array< size_type, reference_element::max_variant >, 4 > &_nxxx_on_subgeo, std::array< std::array< size_type, 5 >, reference_element::max_variant > &_first_ixxx_by_dimension)
static void | _helper_make_discontinuous_ndof_on_subgeo (bool is_continuous, const std::array< std::array< size_type, reference_element::max_variant >, 4 > &nxxx_on_subgeo_internal, std::array< std::array< size_type, reference_element::max_variant >, 4 > &nxxx_on_subgeo)
Protected Attributes inherited from basis_rep< T >
std::string | _name
basis_option | _sopt
piola_fem< T > | _piola_fem
std::array< bool, reference_element::max_variant > | _have_initialize_data
std::array< std::array< size_type,reference_element::max_variant >,4 > | _ndof_on_subgeo_internal
std::array< std::array< size_type,reference_element::max_variant >,4 > | _ndof_on_subgeo
std::array< std::array< size_type,reference_element::max_variant >,4 > | _nnod_on_subgeo_internal
std::array< std::array< size_type,reference_element::max_variant >,4 > | _nnod_on_subgeo
std::array< std::array< size_type,5 >,reference_element::max_variant > | _first_idof_by_dimension_internal
std::array< std::array< size_type,5 >,reference_element::max_variant > | _first_idof_by_dimension
std::array< std::array< size_type,5 >,reference_element::max_variant > | _first_inod_by_dimension_internal
std::array< std::array< size_type,5 >,reference_element::max_variant > | _first_inod_by_dimension

## Member Typedef Documentation

## base

template<class T >

typedef basis_rep<T> base

Definition at line 33 of file P1.h.

## size_type

template<class T >

typedef base::size_type size_type

Definition at line 34 of file P1.h.

## Constructor & Destructor Documentation

## basis_P1()

template<class T >

basis_P1 | ( | const basis_option & | sopt | ) |

Definition at line 370 of file P1.cc.

## ~basis_P1()

template<class T >

~basis_P1 | ( |  | ) |

Definition at line 378 of file P1.cc.

## Member Function Documentation

## have_index_parameter()

template<class T >

bool have_index_parameter | ( |  | ) | const

virtual

Reimplemented from basis_rep< T >.

Definition at line 37 of file P1.h.

## family_name()

template<class T >

std::string family_name | ( |  | ) | const

virtual

Implements basis_rep< T >.

Definition at line 38 of file P1.h.

## local_idof_on_side()

template<class T >

void local_idof_on_side | ( | reference_element | hat_K,
|  | const side_information_type & | sid,
|  | Eigen::Matrix< size_type, Eigen::Dynamic, 1 > & | loc_idof
| ) |  | const

virtual

Reimplemented from basis_rep< T >.

Definition at line 39 of file P1.h.

## degree()

template<class T >

basis_P1< T >::size_type degree | ( |  | ) | const

virtual

Implements basis_rep< T >.

Definition at line 383 of file P1.cc.

## is_nodal()

template<class T >

bool is_nodal | ( |  | ) | const

virtual

Implements basis_rep< T >.

Definition at line 47 of file P1.h.

## evaluate()

template<class T >

void evaluate | ( | reference_element | hat_K,
|  | const point_basic< T > & | hat_x,
|  | Eigen::Matrix< T, Eigen::Dynamic, 1 > & | values
| ) |  | const

Definition at line 389 of file P1.cc.

## grad_evaluate()

template<class T >

void grad_evaluate | ( | reference_element | hat_K,
|  | const point_basic< T > & | hat_x,
|  | Eigen::Matrix< point_basic< T >, Eigen::Dynamic, 1 > & | values
| ) |  | const

Definition at line 423 of file P1.cc.

## _compute_dofs()

template<class T >

void _compute_dofs | ( | reference_element | hat_K,
|  | const Eigen::Matrix< T, Eigen::Dynamic, 1 > & | f_xnod,
|  | Eigen::Matrix< T, Eigen::Dynamic, 1 > & | dof
| ) |  | const

Definition at line 457 of file P1.cc.

## _initialize_cstor_sizes()

template<class T >

void _initialize_cstor_sizes | ( |  | ) | const

virtual

Implements basis_rep< T >.

Definition at line 466 of file P1.cc.

## _initialize_data()

template<class T >

void _initialize_data | ( | reference_element | hat_K | ) | const

virtual

Implements basis_rep< T >.

Definition at line 482 of file P1.cc.

## hat_node()

template<class T >

const Eigen::Matrix< point_basic< T >, Eigen::Dynamic, 1 > & hat_node | ( | reference_element | hat_K | ) | const

virtual

Reimplemented from basis_rep< T >.

Definition at line 62 of file P1.h.

## Member Data Documentation

## _hat_node

template<class T >

std::array< Eigen::Matrix<point_basic<T>,Eigen::Dynamic,1>, reference_element::max_variant> _hat_node

mutable

Definition at line 67 of file P1.h.

The documentation for this class was generated from the following files:

- /build/rheolef-Hrneba/rheolef-7.2/fem/lib/P1.h
- /build/rheolef-Hrneba/rheolef-7.2/fem/lib/P1.cc